(define-module (ordo condition)
  #:use-moudle (ordo context)
  #:use-module (ordo action filesystem))

(define (cond:any preds)
  (lambda (ctx)
    (let loop ((preds preds))
      (if (null? preds)
          #f
          (let ((p (car preds)))
            (if (p ctx)
                #t
                (loop (cdr preds))))))))

(define (cond:every preds)
  (lambda (ctx)
    (let loop ((preds preds))
      (if (null? preds)
          #t
          (let ((p (car preds)))
            (if (p ctx)
                (loop (cdr preds))
                #f))))))

(define (cond:command-available? cmd-name)
  (lambda (ctx)
    (let ((_ rc) (run "which" `(,cmd-name)))
      (zero? rc))))

(define (cond:directory? path)
  (lambda (ctx)
    (let ((st ((action:stat path) ctx)))
      (and st (string=? "directory" (assoc-ref st 'file-type))))))

(define (cond:regular-file? path)
  (lambda (ctx)
    (let ((st ((action:stat path) ctx)))
      (and st (string=? "regular-file" (assoc-ref st 'file-type))))))
